## deepin-upgrade-manager 1.0.17

=== Makefile ===
PRJ=deepin-upgrade-manager
PROG_UPGRADER=${PRJ}
PROG_UPGRADER_TOOL=deepin-upgrade-manager-tool
PROG_BOOTKIT=deepin-boot-kit
PROG_DBUS=org.deepin.AtomicUpgrade1
LANGUAGES_BOOT_KIT = $(basename $(notdir $(wildcard misc/deepin-boot-kit/po/*.po)))
LANGUAGES_UPGRADE_MANAGER = $(basename $(notdir $(wildcard misc/deepin-upgrade-manager/po/*.po)))
PREFIX=/usr
VAR=/var/lib
PWD=$(shell pwd)
GOCODE=/usr/share/gocode
GOPATH_DIR=gopath
CURRENT_DIR=$(notdir $(shell pwd))
ARCH=$(shell arch)
export GO111MODULE=off


all: build

prepare:
	@if [ ! -d ${GOPATH_DIR}/src/${PRJ} ]; then \
		mkdir -p ${GOPATH_DIR}/src/${PRJ}; \
		ln -sf ${PWD}/pkg ${GOPATH_DIR}/src/${PRJ}; \
		ln -sf ${PWD}/cmd ${GOPATH_DIR}/src/${PRJ}/; \
	fi

$(info, $(GOPATH))
$(warning, $(GOPATH))
$(error, $(GOPATH))


build: prepare
	mkdir -p ${PWD}/out
	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} ls -al ${PWD}/${GOPATH_DIR}/src/deepin-upgrade-manager/*
	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} ls -al ${PWD}/${GOPATH_DIR}/src/deepin-upgrade-manager/cmd/deepin-upgrade-manager/*
	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} ls -al ${PWD}/${GOPATH_DIR}/src/deepin-upgrade-manager/cmd/deepin-boot-kit/*

	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH}  \
	CGO_CPPFLAGS="-D_FORTIFY_SOURCE=2"  CGO_LDFLAGS="-Wl,-z,relro,-z,now" \
	go build -o ${PWD}/${PROG_UPGRADER} $(GO_BUILD_FLAGS) ${PRJ}/cmd/${PROG_UPGRADER}

	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} \
	CGO_CPPFLAGS="-D_FORTIFY_SOURCE=2"  CGO_LDFLAGS="-Wl,-z,relro,-z,now" \
	go build -o ${PWD}/${PROG_BOOTKIT} $(GO_BUILD_FLAGS) ${PRJ}/cmd/${PROG_BOOTKIT}

	@env GOPATH=${PWD}/${GOPATH_DIR}:${GOCODE}:${GOPATH} \
	CGO_CPPFLAGS="-D_FORTIFY_SOURCE=2"  CGO_LDFLAGS="-Wl,-z,relro,-z,now" \
	go build -o ${PWD}/${PROG_UPGRADER_TOOL} $(GO_BUILD_FLAGS) ${PRJ}/cmd/${PROG_UPGRADER_TOOL}

install-upgrader:
#ifeq ($(ARCH),sw_64)
#	mkdir -p ${DESTDIR}/etc/grub.d/sw64
#	cp -f ${PWD}/cmd/grub.d/sw/15_deepin-upgrade-manager ${DESTDIR}/etc/grub.d/sw64
#endif
	@mkdir -p ${DESTDIR}/etc/${PROG_UPGRADER}/
	@cp -f ${PWD}/configs/upgrader/config.simple.json  ${DESTDIR}/etc/${PROG_UPGRADER}/config.json

	@mkdir -p ${DESTDIR}/etc/${PROG_UPGRADER}/ready/
	@cp -f ${PWD}/configs/upgrader/data.simple.yaml  ${DESTDIR}/etc/${PROG_UPGRADER}/ready/data.yaml

	@mkdir -p ${DESTDIR}${VAR}/${PROG_BOOTKIT}/config
	@cp -f ${PWD}/configs/upgrader/tool/atomic.json  ${DESTDIR}${VAR}/${PROG_BOOTKIT}/config/atomic.json

	@mkdir -p ${DESTDIR}${VAR}/${PROG_UPGRADER}/scripts
	@cp -f ${PWD}/configs/upgrader/${PROG_UPGRADER} ${DESTDIR}${VAR}/${PROG_UPGRADER}/scripts/

	@mkdir -p ${DESTDIR}${PREFIX}/share/dbus-1/system.d/
	@cp -f ${PWD}/configs/dbus/${PROG_DBUS}.conf  ${DESTDIR}${PREFIX}/share/dbus-1/system.d/

	@mkdir -p ${DESTDIR}${PREFIX}/share/dbus-1/system-services/
	@cp -f ${PWD}/configs/dbus/${PROG_DBUS}.service  ${DESTDIR}${PREFIX}/share/dbus-1/system-services/

	@mkdir -p ${DESTDIR}${PREFIX}/sbin
	@cp -f ${PWD}/${PROG_UPGRADER} ${DESTDIR}${PREFIX}/sbin

	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks
	@cp -f ${PWD}/cmd/initramfs-hook/${PROG_UPGRADER} ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/
	@cp -f ${PWD}/cmd/initramfs-hook/ostree ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/

	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom
	@cp -f ${PWD}/cmd/initramfs-scripts/${PROG_UPGRADER} ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom/

	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/local-bottom
	@cp -f ${PWD}/cmd/initramfs-scripts/${PROG_UPGRADER}-partition-mount ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/local-bottom/

install-upgrader-tool:
	@mkdir -p ${DESTDIR}${PREFIX}/bin
	@cp -f ${PWD}/${PROG_UPGRADER_TOOL} ${DESTDIR}${PREFIX}/bin

	@mkdir -p ${DESTDIR}${PREFIX}/share/${PROG_UPGRADER}
	@cp -f ${PWD}/configs/upgrader/deepin-upgrade-manager-tool.desktop ${DESTDIR}${PREFIX}/share/${PROG_UPGRADER}/deepin-upgrade-manager-tool.desktop

install-bootkit:
	@mkdir -p ${DESTDIR}/usr/share/${PROG_BOOTKIT}/
	@cp -f ${PWD}/configs/bootkit/config.simple.json  ${DESTDIR}/usr/share/${PROG_BOOTKIT}/config.json

	@mkdir -p ${DESTDIR}${PREFIX}/sbin
	@cp -f ${PWD}/${PROG_BOOTKIT} ${DESTDIR}${PREFIX}/sbin/

	@mkdir -p ${DESTDIR}/etc/grub.d ${DESTDIR}/etc/default/grub.d
	@cp -f ${PWD}/cmd/grub.d/15_deepin-boot-kit ${DESTDIR}/etc/grub.d

	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks
	@cp -f ${PWD}/cmd/initramfs-hook/${PROG_BOOTKIT} ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/

	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom
	@cp -f ${PWD}/cmd/initramfs-scripts/${PROG_BOOTKIT} ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom/

	@mkdir -p ${DESTDIR}${VAR}/${PROG_BOOTKIT}

install-translate:
	install -d ${DESTDIR}${PREFIX}/share/locale
	@cp -rfv ${PWD}/out/locale/* ${DESTDIR}${PREFIX}/share/locale

install: translate-bootkit translate-upgrade install-translate install-bootkit install-upgrader-tool install-upgrader

out/locale/%/LC_MESSAGES/deepin-boot-kit.mo: misc/deepin-boot-kit/po/%.po
	mkdir -p ${PWD}/$(@D)
	msgfmt -o ${PWD}/$@ ${PWD}/$<

out/locale/%/LC_MESSAGES/deepin-upgrade-manager.mo: misc/deepin-upgrade-manager/po/%.po
	mkdir -p ${PWD}/$(@D)
	msgfmt -o ${PWD}/$@ ${PWD}/$<

translate-bootkit: $(addsuffix /LC_MESSAGES/deepin-boot-kit.mo, $(addprefix out/locale/, ${LANGUAGES_BOOT_KIT}))

translate-upgrade: $(addsuffix /LC_MESSAGES/deepin-upgrade-manager.mo, $(addprefix out/locale/, ${LANGUAGES_UPGRADE_MANAGER}))

check_code_quality:
	go vet .

pot:
	xgettext -kTr --language=C -o misc/deepin-boot-kit/po/deepin-boot-kit.pot pkg/bootkit/bootkit.go
	xgettext -kTr --language=C -o misc/deepin-upgrade-manager/po/deepin-upgrade-manager.pot pkg/upgrader/upgrader.go

uninstall-upgrader:
#ifeq ($(ARCH),sw_64)
#	rm -f ${DESTDIR}/etc/grub.d/sw64/15_deepin-upgrade-manager
#endif
	@rm -f ${DESTDIR}${PREFIX}/sbin/${PROG_UPGRADER}
	@rm -f ${DESTDIR}${PREFIX}/share/dbus-1/system.d/${PROG_DBUS}.conf
	@rm -f ${DESTDIR}${PREFIX}/share/dbus-1/system-services/${PROG_DBUS}.service
	@rm -f ${DESTDIR}/etc/${PROG_UPGRADER}/config.json
	@rm -f ${DESTDIR}/etc/${PROG_UPGRADER}/ready/data.yaml
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/ostree
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/${PROG_UPGRADER}
	@rm -f ${DESTDIR}${VAR}/${PROG_UPGRADER}/scripts/${PROG_UPGRADER}
	@rm -f ${DESTDIR}${VAR}/${PROG_BOOTKIT}/config/atomic.json
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/local-bottom/${PROG_UPGRADER}
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/local-bottom/${PROG_UPGRADER}-partition-mount

uninstall-upgrader-tool:
	@rm -f ${DESTDIR}${PREFIX}/bin/${PROG_UPGRADER_TOOL}
	@rm -f ${DESTDIR}${PREFIX}/share/${PROG_UPGRADER}/deepin-upgrade-manager-tool.desktop

uninstall-bootkit:
	@rm -f ${DESTDIR}${PREFIX}/sbin/${PROG_BOOTKIT}
	@rm -f ${DESTDIR}/usr/share/${PROG_BOOTKIT}/config.json
	@rm -f ${DESTDIR}/etc/grub.d/15_deepin-boot-kit
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/${PROG_BOOTKIT}
	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom/${PROG_BOOTKIT}
	@rm -f ${DESTDIR}${VAR}/${PROG_BOOTKIT}

uninstall: uninstall-upgrader uninstall-upgrader-tool uninstall-bootkit

clean:
	@rm -rf ${GOPATH_DIR}
	@rm -rf ${PWD}/${PROG_UPGRADER}
	@rm -rf ${PWD}/${PROG_UPGRADER_TOOL}
	@rm -rf ${PWD}/${PROG_BOOTKIT}
	@rm -rf ${PWD}/out

rebuild: clean build

## deepin-upgrade-manager 1.0.16

=== debian/changelog ===
deepin-upgrade-manager (1.0.16-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Mon, 26 Dec 2022 17:00:22 +0800

deepin-upgrade-manager (1.0.16) unstable; urgency=medium

  * Fix submit failure in cgroup partition

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue Dec 13 09:39:05 2022 +0800

deepin-upgrade-manager (1.0.15) unstable; urgency=medium

  * Fix the log output

 -- Chenghao Liu <liuchenghao@uniontech.com>  Wed, 7 Dec 2022 17:22:03 +0800

deepin-upgrade-manager (1.0.14) unstable; urgency=medium

  * Increase the initramfs update grub function

 -- Chenghao Liu <liuchenghao@uniontech.com>  Fri, 2 Dec 2022 17:22:03 +0800

deepin-upgrade-manager (1.0.13) unstable; urgency=medium

  * Adaptation to upgrade tool

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 22 Nov 2022 17:22:03 +0800

deepin-upgrade-manager (1.0.12) unstable; urgency=medium

  * Increase the profile design documents

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 1 Nov 2022 17:22:03 +0800

deepin-upgrade-manager (1.0.11) unstable; urgency=medium

  * Adding custom backup filtration field interface

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 1 Nov 2022 17:22:03 +0800

deepin-upgrade-manager (1.0.10) unstable; urgency=medium

  * Fix the LVM partition rollback failed

 -- Chenghao Liu <liuchenghao@uniontech.com>  Fri, 16 Sep 2022 13:43:03 +0800

deepin-upgrade-manager (1.0.9) unstable; urgency=medium

  * Add adapter lvm partition

 -- Chenghao Liu <liuchenghao@uniontech.com>  Fri, 2 Sep 2022 15:48:03 +0800

deepin-upgrade-manager (1.0.8) unstable; urgency=medium

  * Add adapter multiple partition

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 18 Aug 2022 16:24:03 +0800

deepin-upgrade-manager (1.0.7) unstable; urgency=medium

  * Add adapter v20 system
  * Fix failed rollback in dbus and cmd

 -- Chenghao Liu <liuchenghao@uniontech.com>  Mon, 8 Aug 2022 13:24:03 +0800

deepin-upgrade-manager (1.0.6) unstable; urgency=medium

  * Add rollback notify
  * Add more than language adaptation
  * Add the grub encryption

 -- Chenghao Liu <liuchenghao@uniontech.com>  Mon, 1 Aug 2022 11:24:03 +0800

deepin-upgrade-manager (1.0.5) unstable; urgency=medium

  * Fit deepin-boot-kit manager grub

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 16 Jul 2022 11:24:03 +0800

deepin-upgrade-manager (1.0.4) unstable; urgency=medium

  * Fix auto cleanup
 -- Chenghao Liu <liuchenghao@uniontech.com>  Thu, 16 Jun 2022 9:24:03 +0800

deepin-upgrade-manager (1.0.3) unstable; urgency=medium

  * Add dbus interface

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 7 Jun 2022 16:24:03 +0800

deepin-upgrade-manager (1.0.2) unstable; urgency=medium

  * Add dbus interface
  * The configuration file adds filtering function
  * Add error code
 -- Chenghao Liu <liuchenghao@uniontech.com>  Mon, 23 May 2022 14:24:03 +0800

deepin-upgrade-manager (1.0.1) unstable; urgency=medium

  * Refactor upgrade manager

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 26 April 2022 14:24:03 +0800

=== debian/control ===
Source: deepin-upgrade-manager
Section: utils
Priority: optional
Maintainer: LinuxDeepin <linuxdeepin@deepin.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-golang,
 golang-any,
 golang-dbus-dev,
 golang-gopkg-yaml.v2-dev
Standards-Version: 4.5.1
Homepage: https://www.deepin.org
#Vcs-Browser: https://salsa.debian.org/debian/asldfk
#Vcs-Git: https://salsa.debian.org/debian/asldfk.git
Rules-Requires-Root: no

Package: deepin-upgrade-manager
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ostree,
 deepin-boot-kit,
Description: uos backup and restore tool
 uos system backup and restore tool in Linux.

Package: deepin-boot-kit
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: uos rollback the grub management tool
 uos system manage rollback grub in Linux.

## deepin-upgrade-manager 1.0.17

=== debian/changelog ===
deepin-upgrade-manager (1.0.17-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Mon, 06 Feb 2023 16:28:14 +0800

deepin-upgrade-manager (1.0.17) unstable; urgency=medium

  * Feat create rootfs in maximum partition function

 -- Chenghao Liu <liuchenghao@uniontech.com>  Tue, 27 Dec 2022 13:40:12 +0800

## deepin-upgrade-manager 1.0.18

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,8 @@
 		mkdir -p ${GOPATH_DIR}/src/${PRJ}; \
 		ln -sf ${PWD}/pkg ${GOPATH_DIR}/src/${PRJ}; \
 		ln -sf ${PWD}/cmd ${GOPATH_DIR}/src/${PRJ}/; \
+		ln -sf ${PWD}/go.mod ${GOPATH_DIR}/src/${PRJ}; \
+		ln -sf ${PWD}/go.sum ${GOPATH_DIR}/src/${PRJ}; \
 	fi
 
 $(info, $(GOPATH))

=== debian/changelog ===
deepin-upgrade-manager (1.0.18) unstable; urgency=medium

  * Revert:fix grub waiting too long.

 -- LiChengGang <lichenggang@uniontech.com>  Mon, 17 Apr 2023 16:49:04 +0800

## deepin-upgrade-manager 1.0.19

=== debian/changelog ===
deepin-upgrade-manager (1.0.19) unstable; urgency=medium

  * fix: modify autostart #3819
  * The repair program could not be started automatically

 -- LiChengGang <lichenggang@uniontech.com>  Tue, 09 May 2023 11:25:48 +0800

## deepin-upgrade-manager 1.0.22

=== debian/changelog ===
deepin-upgrade-manager (1.0.22-1) unstable; urgency=medium

  * update

 -- LinuxDeepin <linuxdeepin@deepin.org>  Mon, 18 Sep 2023 11:04:43 +0800

deepin-upgrade-manager (1.0.22) unstable; urgency=medium

  * fix backup system failed 
  * issues: https://github.com/linuxdeepin/developer-center/issues/5577

 -- LiChengGang <lichenggang@uniontech.com>  Fri, 15 Sep 2023 13:10:48 +0800

deepin-upgrade-manager (1.0.21) unstable; urgency=medium

  * fix rollback failed

 -- Lin Xin <linxin@deepin.org>  Tue, 30 May 2023 10:01:00 +0800

deepin-upgrade-manager (1.0.20) unstable; urgency=medium

  * fix: upgrade failed in multi-systems
  * fix: upgrade failed in multi-kernels

 -- Lin Xin <linxin@deepin.org>  Wed, 24 May 2023 09:50:22 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
export GOPATH := /usr/share/gocode
export GOCACHE := /tmp/gocache

ifneq ($(DEB_BUILD_ARCH), mips64el)
	export GO_BUILD_FLAGS=-ldflags '-linkmode=external -extldflags "-pie"'
endif

%:
	dh $@

override_dh_dwz:

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

ifeq ($(DEB_BUILD_ARCH),sw_64)
override_dh_strip:
	true
override_dh_auto_test:
	true
endif

## deepin-upgrade-manager 1.0.27

=== Makefile ===
--- 
+++ 
@@ -100,7 +100,7 @@
 	@cp -f ${PWD}/${PROG_BOOTKIT} ${DESTDIR}${PREFIX}/sbin/
 
 	@mkdir -p ${DESTDIR}/etc/grub.d ${DESTDIR}/etc/default/grub.d
-	@cp -f ${PWD}/cmd/grub.d/15_deepin-boot-kit ${DESTDIR}/etc/grub.d
+	@cp -f ${PWD}/cmd/grub.d/99_deepin-boot-kit ${DESTDIR}/etc/grub.d
 
 	@mkdir -p ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks
 	@cp -f ${PWD}/cmd/initramfs-hook/${PROG_BOOTKIT} ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/
@@ -110,11 +110,15 @@
 
 	@mkdir -p ${DESTDIR}${VAR}/${PROG_BOOTKIT}
 
+install-plymouth:
+	install -d ${DESTDIR}${PREFIX}/share/plymouth/themes
+	@cp -rvf ${PWD}/misc/plymouth/themes/deepin-recovery ${DESTDIR}${PREFIX}/share/plymouth/themes/
+
 install-translate:
 	install -d ${DESTDIR}${PREFIX}/share/locale
 	@cp -rfv ${PWD}/out/locale/* ${DESTDIR}${PREFIX}/share/locale
 
-install: translate-bootkit translate-upgrade install-translate install-bootkit install-upgrader-tool install-upgrader
+install: translate-bootkit translate-upgrade install-translate install-bootkit install-upgrader-tool install-upgrader install-plymouth
 
 out/locale/%/LC_MESSAGES/deepin-boot-kit.mo: misc/deepin-boot-kit/po/%.po
 	mkdir -p ${PWD}/$(@D)
@@ -158,12 +162,15 @@
 uninstall-bootkit:
 	@rm -f ${DESTDIR}${PREFIX}/sbin/${PROG_BOOTKIT}
 	@rm -f ${DESTDIR}/usr/share/${PROG_BOOTKIT}/config.json
-	@rm -f ${DESTDIR}/etc/grub.d/15_deepin-boot-kit
+	@rm -f ${DESTDIR}/etc/grub.d/99_deepin-boot-kit
 	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/hooks/${PROG_BOOTKIT}
 	@rm -f ${DESTDIR}${PREFIX}/share/initramfs-tools/scripts/init-bottom/${PROG_BOOTKIT}
 	@rm -f ${DESTDIR}${VAR}/${PROG_BOOTKIT}
 
-uninstall: uninstall-upgrader uninstall-upgrader-tool uninstall-bootkit
+uninstall-plymouth:
+	@rm -rf ${DESTDIR}${PREFIX}/share/plymouth/themes/deepin-recovery
+
+uninstall: uninstall-upgrader uninstall-upgrader-tool uninstall-bootkit uninstall-plymouth
 
 clean:
 	@rm -rf ${GOPATH_DIR}

=== debian/changelog ===
deepin-upgrade-manager (1.0.27) unstable; urgency=medium

  * Reduced MaxVersionRetention from 5 to 2.
    Previously, with MaxVersionRetention set to 5, the /boot/ partition could
    retain up to 5 versions of kernel and initramfs files. Assuming each
    version's kernel and initramfs files together occupy 100MB, this would
    result in:

    5 versions × 3 kernels × 100 MB = 1.5 GB

    Given that our default /boot partition size is 1.5GB, this configuration
    would lead to insufficient space, causing update failures and other
    issues.

    This change helps prevent the /boot/ partition from running out of space
    by limiting the number of retained kernel and initramfs versions.

 -- Tianyu Chen <sweetyfish@deepin.org>  Thu, 16 May 2024 17:41:46 +0800

deepin-upgrade-manager (1.0.26) unstable; urgency=medium

  * Allow customizing theme

 -- Yutao Meng <mengyutao@deepin.org>  Tue, 19 Mar 2024 15:10:19 +0800

deepin-upgrade-manager (1.0.25) unstable; urgency=medium

  * bump version to 1.0.25

 -- Lin Xin <linxin@deepin.org>  Tue, 30 Jan 2024 09:43:40 +0800

deepin-upgrade-manager (1.0.24) unstable; urgency=medium

  * fix: conflict with deepin-system-upgrade in plymouth 

 -- Lin Xin <linxin@deepin.org>  Wed, 24 Jan 2024 10:13:38 +0800

deepin-upgrade-manager (1.0.23) unstable; urgency=medium

  * fix: https://github.com/linuxdeepin/developer-center/issues/6409
  * fix: https://github.com/linuxdeepin/developer-center/issues/6855

 -- Lin Xin <linxin@deepin.org>  Mon, 15 Jan 2024 16:43:34 +0800
